//+------------------------------------------------------------------+
//|                                Trend direction & force index.mq4 |
//|                                                           mladen |
//| original metastock indicator made by Piotr Wojdylo               |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
#property indicator_separate_window
#property indicator_maximum  1
#property indicator_minimum  -1
#property indicator_buffers  5
#property indicator_color1   DarkSlateGray
#property indicator_color2   Lime
#property indicator_color3   Lime
#property indicator_color4   Red
#property indicator_color5   Red

extern int    TrendPeriod    = 9; //9=ema36 original tdfi
extern int    mnj            = 3;
int length1,length2,length3,length4,tr1,tr2,tr3,tr4;
double B0[],B1[],B2[],B3[],B4[],Btr1[],Btr2[],Bup[],Bdw[],
 B1_1[],B1_2[],B1_3[],  B2_1[],B2_2[],B2_3[],  B3_1[],B3_2[],B3_3[],  B4_1[],B4_2[],B4_3[],
        B5_2[],B5_3[],         B6_2[],B6_3[],         B7_2[],B7_3[],         B8_2[],B8_3[],
        B9_2[],B9_3[],         B10_2[],B10_3[],       B11_2[],B11_3[],       B12_2[],B12_3[],
        B13_2[],B13_3[],       B14_2[],B14_3[],       B15_2[],B15_3[],       B16_2[],B16_3[];

int init(){
   IndicatorBuffers(45);
   SetIndexBuffer(0,B0);
   SetIndexBuffer(1,B1);    SetIndexLabel(1,NULL);
   SetIndexBuffer(2,B2);    SetIndexLabel(2,NULL);
   SetIndexBuffer(3,B3);    SetIndexLabel(3,NULL);
   SetIndexBuffer(4,B4);    SetIndexLabel(4,NULL);
   SetIndexBuffer(5,Btr1);
   SetIndexBuffer(6,Btr2);
   //SetIndexBuffer(7,Bup);
   //SetIndexBuffer(8,Bdw);
   SetIndexBuffer(9,B1_1);  SetIndexBuffer(10,B1_2);  SetIndexBuffer(11,B1_3);
   SetIndexBuffer(12,B2_1); SetIndexBuffer(13,B2_2);  SetIndexBuffer(14,B2_3);
   SetIndexBuffer(15,B3_1); SetIndexBuffer(16,B3_2);  SetIndexBuffer(17,B3_3);
   SetIndexBuffer(18,B4_1); SetIndexBuffer(19,B4_2);  SetIndexBuffer(20,B4_3);
                            SetIndexBuffer(21,B5_2);  SetIndexBuffer(22,B5_3);
                            SetIndexBuffer(23,B6_2);  SetIndexBuffer(24,B6_3);
                            SetIndexBuffer(25,B7_2);  SetIndexBuffer(26,B7_3);
                            SetIndexBuffer(27,B8_2);  SetIndexBuffer(28,B8_3);
                            SetIndexBuffer(29,B9_2);  SetIndexBuffer(30,B9_3);
                            SetIndexBuffer(31,B10_2); SetIndexBuffer(32,B10_3);
                            SetIndexBuffer(33,B11_2); SetIndexBuffer(34,B11_3);
                            SetIndexBuffer(35,B12_2); SetIndexBuffer(36,B12_3);
                            SetIndexBuffer(37,B13_2); SetIndexBuffer(38,B13_3);
                            SetIndexBuffer(39,B14_2); SetIndexBuffer(40,B14_3);
                            SetIndexBuffer(41,B15_2); SetIndexBuffer(42,B15_3);
                            SetIndexBuffer(43,B16_2); SetIndexBuffer(44,B16_3);
   IndicatorShortName(NULL);
   tr1=TrendPeriod*2; tr2=TrendPeriod*3; tr3=TrendPeriod*4; tr4=TrendPeriod*5;
   length1=tr4*mnj;
   return(0);
}

int start(){int i,limit=Bars-IndicatorCounted()-1; double b4,m1,m2,m3,m4,t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15,t16;
 for(i=limit;i>=0;i--){B1_1[i]=iMA(NULL,0,tr1,0,2,0,i); B2_1[i]=iMA(NULL,0,tr2,0,0,0,i); B3_1[i]=iMA(NULL,0,tr3,0,1,0,i); B4_1[i]=iMA(NULL,0,tr4,0,3,0,i); }
 for(i=limit;i>=0;i--){m1=B1_1[i]-B1_1[i+1]; m2=B2_1[i]-B2_1[i+1]; m3=B3_1[i]-B3_1[i+1]; m4=B4_1[i]-B4_1[i+1];
  B1_2[i] =iMAOnArray(B1_1,0,tr1,0,2,i); B1_3[i] =MathAbs(B1_1[i]-B1_2[i]) *(m1+B1_2[i] -B1_2[i+1]);  b4=MathMax(MathAbs(B1_3[ ArrayMaximum(B1_3, length1,i)]),MathAbs(B1_3[ ArrayMinimum(B1_3, length1,i)])); if(b4>0){t1 =B1_3[i] /b4;}else{t1 =0;}
  B2_2[i] =iMAOnArray(B2_1,0,tr2,0,0,i); B2_3[i] =MathAbs(B2_1[i]-B2_2[i]) *(m2+B2_2[i] -B2_2[i+1]);  b4=MathMax(MathAbs(B2_3[ ArrayMaximum(B2_3, length1,i)]),MathAbs(B2_3[ ArrayMinimum(B2_3, length1,i)])); if(b4>0){t2 =B2_3[i] /b4;}else{t2 =0;}
  B3_2[i] =iMAOnArray(B3_1,0,tr3,0,1,i); B3_3[i] =MathAbs(B3_1[i]-B3_2[i]) *(m3+B3_2[i] -B3_2[i+1]);  b4=MathMax(MathAbs(B3_3[ ArrayMaximum(B3_3, length1,i)]),MathAbs(B3_3[ ArrayMinimum(B3_3, length1,i)])); if(b4>0){t3 =B3_3[i] /b4;}else{t3 =0;}
  B4_2[i] =iMAOnArray(B4_1,0,tr4,0,3,i); B4_3[i] =MathAbs(B4_1[i]-B4_2[i]) *(m4+B4_2[i] -B4_2[i+1]);  b4=MathMax(MathAbs(B4_3[ ArrayMaximum(B4_3, length1,i)]),MathAbs(B4_3[ ArrayMinimum(B4_3, length1,i)])); if(b4>0){t4 =B4_3[i] /b4;}else{t4 =0;}
  B5_2[i] =iMAOnArray(B1_1,0,tr4,0,3,i); B5_3[i] =MathAbs(B1_1[i]-B5_2[i]) *(m1+B5_2[i] -B5_2[i+1]);  b4=MathMax(MathAbs(B5_3[ ArrayMaximum(B5_3, length1,i)]),MathAbs(B5_3[ ArrayMinimum(B5_3, length1,i)])); if(b4>0){t5 =B5_3[i] /b4;}else{t5 =0;}
  B6_2[i] =iMAOnArray(B2_1,0,tr1,0,2,i); B6_3[i] =MathAbs(B2_1[i]-B6_2[i]) *(m2+B6_2[i] -B6_2[i+1]);  b4=MathMax(MathAbs(B6_3[ ArrayMaximum(B6_3, length1,i)]),MathAbs(B6_3[ ArrayMinimum(B6_3, length1,i)])); if(b4>0){t6 =B6_3[i] /b4;}else{t6 =0;}
  B7_2[i] =iMAOnArray(B3_1,0,tr2,0,0,i); B7_3[i] =MathAbs(B3_1[i]-B7_2[i]) *(m3+B7_2[i] -B7_2[i+1]);  b4=MathMax(MathAbs(B7_3[ ArrayMaximum(B7_3, length1,i)]),MathAbs(B7_3[ ArrayMinimum(B7_3, length1,i)])); if(b4>0){t7 =B7_3[i] /b4;}else{t7 =0;}
  B8_2[i] =iMAOnArray(B4_1,0,tr3,0,1,i); B8_3[i] =MathAbs(B4_1[i]-B8_2[i]) *(m4+B8_2[i] -B8_2[i+1]);  b4=MathMax(MathAbs(B8_3[ ArrayMaximum(B8_3, length1,i)]),MathAbs(B8_3[ ArrayMinimum(B8_3, length1,i)])); if(b4>0){t8 =B8_3[i] /b4;}else{t8 =0;}
  B9_2[i] =iMAOnArray(B1_1,0,tr3,0,1,i); B9_3[i] =MathAbs(B1_1[i]-B9_2[i]) *(m1+B9_2[i] -B9_2[i+1]);  b4=MathMax(MathAbs(B9_3[ ArrayMaximum(B9_3, length1,i)]),MathAbs(B9_3[ ArrayMinimum(B9_3, length1,i)])); if(b4>0){t9 =B9_3[i] /b4;}else{t9 =0;}
  B10_2[i]=iMAOnArray(B2_1,0,tr4,0,3,i); B10_3[i]=MathAbs(B2_1[i]-B10_2[i])*(m2+B10_2[i]-B10_2[i+1]); b4=MathMax(MathAbs(B10_3[ArrayMaximum(B10_3,length1,i)]),MathAbs(B10_3[ArrayMinimum(B10_3,length1,i)])); if(b4>0){t10=B10_3[i]/b4;}else{t10=0;}
  B11_2[i]=iMAOnArray(B3_1,0,tr1,0,2,i); B11_3[i]=MathAbs(B3_1[i]-B11_2[i])*(m3+B11_2[i]-B11_2[i+1]); b4=MathMax(MathAbs(B11_3[ArrayMaximum(B11_3,length1,i)]),MathAbs(B11_3[ArrayMinimum(B11_3,length1,i)])); if(b4>0){t11=B11_3[i]/b4;}else{t11=0;}
  B12_2[i]=iMAOnArray(B4_1,0,tr2,0,0,i); B12_3[i]=MathAbs(B4_1[i]-B12_2[i])*(m4+B12_2[i]-B12_2[i+1]); b4=MathMax(MathAbs(B12_3[ArrayMaximum(B12_3,length1,i)]),MathAbs(B12_3[ArrayMinimum(B12_3,length1,i)])); if(b4>0){t12=B12_3[i]/b4;}else{t12=0;}
  B13_2[i]=iMAOnArray(B1_1,0,tr2,0,0,i); B13_3[i]=MathAbs(B1_1[i]-B13_2[i])*(m1+B13_2[i]-B13_2[i+1]); b4=MathMax(MathAbs(B13_3[ArrayMaximum(B13_3,length1,i)]),MathAbs(B13_3[ArrayMinimum(B13_3,length1,i)])); if(b4>0){t13=B13_3[i]/b4;}else{t13=0;}
  B14_2[i]=iMAOnArray(B2_1,0,tr3,0,1,i); B14_3[i]=MathAbs(B2_1[i]-B14_2[i])*(m2+B14_2[i]-B14_2[i+1]); b4=MathMax(MathAbs(B14_3[ArrayMaximum(B14_3,length1,i)]),MathAbs(B14_3[ArrayMinimum(B14_3,length1,i)])); if(b4>0){t14=B14_3[i]/b4;}else{t14=0;}
  B15_2[i]=iMAOnArray(B3_1,0,tr4,0,3,i); B15_3[i]=MathAbs(B3_1[i]-B15_2[i])*(m3+B15_2[i]-B15_2[i+1]); b4=MathMax(MathAbs(B15_3[ArrayMaximum(B15_3,length1,i)]),MathAbs(B15_3[ArrayMinimum(B15_3,length1,i)])); if(b4>0){t15=B15_3[i]/b4;}else{t15=0;}
  B16_2[i]=iMAOnArray(B4_1,0,tr1,0,2,i); B16_3[i]=MathAbs(B4_1[i]-B16_2[i])*(m4+B16_2[i]-B16_2[i+1]); b4=MathMax(MathAbs(B16_3[ArrayMaximum(B16_3,length1,i)]),MathAbs(B16_3[ArrayMinimum(B16_3,length1,i)])); if(b4>0){t16=B16_3[i]/b4;}else{t16=0;}
  Btr1[i]=Btr1[i+1]; Btr2[i]=Btr2[i+1];
  if(t1>0 && t2>0 && t3>0 && t4>0 && t5>0 && t6>0 && t7>0 && t8>0 && t9>0 && t10>0 && t11>0 && t12>0 && t13>0 && t14>0 && t15>0 && t16>0
     && Close[i]>B1_1[i] && Close[i]>B2_1[i] && Close[i]>B3_1[i] && Close[i]>B4_1[i]  && Close[i]>B1_2[i]  && Close[i]>B2_2[i]  && Close[i]>B3_2[i]  && Close[i]>B4_2[i]  && Close[i]>B5_2[i]  && Close[i]>B6_2[i]
     && Close[i]>B7_2[i] && Close[i]>B8_2[i] && Close[i]>B9_2[i] && Close[i]>B10_2[i] && Close[i]>B11_2[i] && Close[i]>B12_2[i] && Close[i]>B13_2[i] && Close[i]>B14_2[i] && Close[i]>B15_2[i] && Close[i]>B16_2[i]
     && (High[ArrayMaximum(High,TrendPeriod,i+1)]<Close[i] || Btr2[i+1]== 1)
     && B1_1[i+1]<B1_1[i] && B2_1[i+1]<B2_1[i] && B3_1[i+1]<B3_1[i] && B4_1[i+1]<B4_1[i])
     {B0[i]=MathMax(MathMax(MathMax(MathMax(t1,t2), MathMax(t3,t4)),  MathMax(MathMax(t5,t6),  MathMax(t7,t8))),
                    MathMax(MathMax(MathMax(t9,t10),MathMax(t11,t12)),MathMax(MathMax(t13,t14),MathMax(t15,t16))));  Btr1[i]= 1; Btr2[i]= 1;}else{
  if(t1<0 && t2<0 && t3<0 && t4<0 && t5<0 && t6<0 && t7<0 && t8<0 && t9<0 && t10<0 && t11<0 && t12<0 && t13<0 && t14<0 && t15<0 && t16<0
     && Close[i]<B1_1[i] && Close[i]<B2_1[i] && Close[i]<B3_1[i] && Close[i]<B4_1[i]  && Close[i]<B1_2[i]  && Close[i]<B2_2[i]  && Close[i]<B3_2[i]  && Close[i]<B4_2[i]  && Close[i]<B5_2[i]  && Close[i]<B6_2[i]
     && Close[i]<B7_2[i] && Close[i]<B8_2[i] && Close[i]<B9_2[i] && Close[i]<B10_2[i] && Close[i]<B11_2[i] && Close[i]<B12_2[i] && Close[i]<B13_2[i] && Close[i]<B14_2[i] && Close[i]<B15_2[i] && Close[i]<B16_2[i]
     && (Low[ArrayMinimum(Low,TrendPeriod,i+1)]>Close[i] || Btr2[i+1]==-1)
     && B1_1[i+1]>B1_1[i] && B2_1[i+1]>B2_1[i] && B3_1[i+1]>B3_1[i] && B4_1[i+1]>B4_1[i])
     {B0[i]=MathMin(MathMin(MathMin(MathMin(t1,t2), MathMin(t3,t4)),  MathMin(MathMin(t5,t6),  MathMin(t7,t8))),
                    MathMin(MathMin(MathMin(t9,t10),MathMin(t11,t12)),MathMin(MathMin(t13,t14),MathMin(t15,t16))));  Btr1[i]=-1; Btr2[i]=-1;}else{B0[i]=(t1+t2+t3+t4+t5+t6+t7+t8+t9+t10+t11+t12+t13+t14+t15+t16)*0.0625; Btr2[i]=0;}}
  if(Btr2[i]== 1){B3[i]=EMPTY_VALUE; B4[i]=EMPTY_VALUE;
                  if(Btr2[i+1]== 1)                                                                                          {B1[i+1]=B0[i+1]; B1[i]=B0[i];}else
                  if(Btr2[i+1]<  1){if((B2[i+2]!=EMPTY_VALUE && B2[i+3]!=EMPTY_VALUE) || (Btr2[i+2]< 1)){B1[i+2]=EMPTY_VALUE; B1[i+1]=B0[i+1]; B1[i]=B0[i];}else
                                     if(B1[i+2]!=EMPTY_VALUE && B1[i+3]!=EMPTY_VALUE)                   {B2[i+2]=EMPTY_VALUE; B2[i+1]=B0[i+1]; B2[i]=B0[i];}}}else
  if(Btr2[i]== 0){B1[i]=EMPTY_VALUE; B2[i]=EMPTY_VALUE; B3[i]=EMPTY_VALUE; B4[i]=EMPTY_VALUE;}else
  if(Btr2[i]==-1){B1[i]=EMPTY_VALUE; B2[i]=EMPTY_VALUE;
                  if(Btr2[i+1]==-1)                                                                                          {B3[i+1]=B0[i+1]; B3[i]=B0[i];}else
                  if(Btr2[i+1]> -1){if((B4[i+2]!=EMPTY_VALUE && B4[i+3]!=EMPTY_VALUE) || (Btr2[i+2]>-1)){B3[i+2]=EMPTY_VALUE; B3[i+1]=B0[i+1]; B3[i]=B0[i];}else
                                     if(B3[i+2]!=EMPTY_VALUE && B3[i+3]!=EMPTY_VALUE)                   {B4[i+2]=EMPTY_VALUE; B4[i+1]=B0[i+1]; B4[i]=B0[i];}}}}
 return(0);
}